import os
import sys

from PyQt6.QtWidgets import QApplication

from src.ui import OptimizationUI


def main() -> None:
    """Program entrypoint."""
    # The pyqt6 python package only ships Windows and Fusion styles,
    # ignore any style overrides unless it's one of these two to avoid warnings.
    # Default to Fusion in this case.
    qt_style = os.environ.get("QT_STYLE_OVERRIDE")
    if qt_style not in {"Windows", "Fusion"}:
        os.environ["QT_STYLE_OVERRIDE"] = "Fusion"

    app = QApplication(sys.argv)
    window = OptimizationUI()
    window.show()
    sys.exit(app.exec())


if __name__ == "__main__":
    main()
